import{s as It,f as Tt,n as Gt,o as St}from"../chunks/scheduler.37c15a92.js";import{S as Dt,i as Ft,g as n,s as i,r as kt,m as H,H as ot,A as jt,h as l,f as s,c as p,j as lt,u as zt,x as r,n as C,B as ct,k as $,y as u,a as e,v as Ht,d as Ct,t as $t,w as Pt}from"../chunks/index.7cb9c9b8.js";import{H as Nt,E as Rt}from"../chunks/EditOnGithub.858acfec.js";function Ut(ht){let o,A,P,E,g,I,f,ut="We learned that <strong>Q-Learning is an algorithm we use to train our Q-Function</strong>, an <strong>action-value function</strong> that determines the value of being at a particular state and taking a specific action at that state.",G,d,gt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-function.jpg" alt="Q-function"/>',S,v,ft="The <strong>Q comes from “the Quality” of that action at that state.</strong>",D,w,dt="Internally, our Q-function is encoded by <strong>a Q-table, a table where each cell corresponds to a state-action pair value.</strong> Think of this Q-table as <strong>the memory or cheat sheet of our Q-function.</strong>",F,x,vt=`The problem is that Q-Learning is a <em>tabular method</em>. This becomes a problem if the states and actions spaces <strong>are not small enough to be represented efficiently by arrays and tables</strong>. In other words: it is <strong>not scalable</strong>.
Q-Learning worked well with small state space environments like:`,j,b,wt="<li>FrozenLake, we had 16 states.</li> <li>Taxi-v3, we had 500 states.</li>",N,_,xt="But think of what we’re going to do today: we will train an agent to learn to play Space Invaders, a more complex game, using the frames as input.",R,m,pt,z,bt='<a href="https://twitter.com/meln1k" rel="nofollow">Nikita Melkozerov mentioned</a>, Atari environments',mt,U,qt='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>25</mn><msup><mn>6</mn><mrow><mn>210</mn><mo>×</mo><mn>160</mn><mo>×</mo><mn>3</mn></mrow></msup><mo>=</mo><mn>25</mn><msup><mn>6</mn><mn>100800</mn></msup></mrow><annotation encoding="application/x-tex">256^{210 \\times 160 \\times 3} = 256^{100800}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8141em;"></span><span class="mord">25</span><span class="mord"><span class="mord">6</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8141em;"><span style="top:-3.063em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">210</span><span class="mbin mtight">×</span><span class="mord mtight">160</span><span class="mbin mtight">×</span><span class="mord mtight">3</span></span></span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.8141em;"></span><span class="mord">25</span><span class="mord"><span class="mord">6</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8141em;"><span style="top:-3.063em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">100800</span></span></span></span></span></span></span></span></span></span></span></span>',B,O,At='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><msup><mn>0</mn><mn>80</mn></msup></mrow><annotation encoding="application/x-tex">10^{80}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8141em;"></span><span class="mord">1</span><span class="mord"><span class="mord">0</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8141em;"><span style="top:-3.063em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">80</span></span></span></span></span></span></span></span></span></span></span></span>',W,J,y,_t="<li>A single frame in Atari is composed of an image of 210x160 pixels. Given that the images are in color (RGB), there are 3 channels. This is why the shape is (210, 160, 3). For each pixel, the value can go from 0 to 255.</li>",K,L,yt,V,c,rt,X,Et='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>Q</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">Q_{\\theta}(s,a)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal">Q</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',Y,Z,M,Lt="This neural network will approximate, given a state, the different Q-values for each possible action at that state. And that’s exactly what Deep Q-Learning does.",tt,Q,Mt,st,T,Qt="Now that we understand Deep Q-Learning, let’s dive deeper into the Deep Q-Network.",at,k,et,q,nt;return g=new Nt({props:{title:"From Q-Learning to Deep Q-Learning",local:"from-q-to-dqn",headingTag:"h1"}}),k=new Rt({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit3/from-q-to-dqn.mdx"}}),{c(){o=n("meta"),A=i(),P=n("p"),E=i(),kt(g.$$.fragment),I=i(),f=n("p"),f.innerHTML=ut,G=i(),d=n("figure"),d.innerHTML=gt,S=i(),v=n("p"),v.innerHTML=ft,D=i(),w=n("p"),w.innerHTML=dt,F=i(),x=n("p"),x.innerHTML=vt,j=i(),b=n("ul"),b.innerHTML=wt,N=i(),_=n("p"),_.textContent=xt,R=i(),m=n("p"),pt=H("As "),z=n("strong"),z.innerHTML=bt,mt=H(" have an observation space with a shape of (210, 160, 3)*, containing values ranging from 0 to 255 so that gives us"),U=new ot(!1),B=H(" possible observations (for comparison, we have approximately"),O=new ot(!1),W=H(" atoms in the observable universe)."),J=i(),y=n("ul"),y.innerHTML=_t,K=i(),L=n("img"),V=i(),c=n("p"),rt=H("Therefore, the state space is gigantic; due to this, creating and updating a Q-table for that environment would not be efficient. In this case, the best idea is to approximate the Q-values using a parametrized Q-function "),X=new ot(!1),Y=H("  ."),Z=i(),M=n("p"),M.textContent=Lt,tt=i(),Q=n("img"),st=i(),T=n("p"),T.textContent=Qt,at=i(),kt(k.$$.fragment),et=i(),q=n("p"),this.h()},l(t){const a=jt("svelte-u9bgzb",document.head);o=l(a,"META",{name:!0,content:!0}),a.forEach(s),A=p(t),P=l(t,"P",{}),lt(P).forEach(s),E=p(t),zt(g.$$.fragment,t),I=p(t),f=l(t,"P",{"data-svelte-h":!0}),r(f)!=="svelte-1rjdaln"&&(f.innerHTML=ut),G=p(t),d=l(t,"FIGURE",{"data-svelte-h":!0}),r(d)!=="svelte-gz4b9g"&&(d.innerHTML=gt),S=p(t),v=l(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-148602q"&&(v.innerHTML=ft),D=p(t),w=l(t,"P",{"data-svelte-h":!0}),r(w)!=="svelte-gdw4y7"&&(w.innerHTML=dt),F=p(t),x=l(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1ghk6ck"&&(x.innerHTML=vt),j=p(t),b=l(t,"UL",{"data-svelte-h":!0}),r(b)!=="svelte-1qtovsz"&&(b.innerHTML=wt),N=p(t),_=l(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1ovrzpg"&&(_.textContent=xt),R=p(t),m=l(t,"P",{});var h=lt(m);pt=C(h,"As "),z=l(h,"STRONG",{"data-svelte-h":!0}),r(z)!=="svelte-10s0md3"&&(z.innerHTML=bt),mt=C(h," have an observation space with a shape of (210, 160, 3)*, containing values ranging from 0 to 255 so that gives us"),U=ct(h,!1),B=C(h," possible observations (for comparison, we have approximately"),O=ct(h,!1),W=C(h," atoms in the observable universe)."),h.forEach(s),J=p(t),y=l(t,"UL",{"data-svelte-h":!0}),r(y)!=="svelte-1cx174r"&&(y.innerHTML=_t),K=p(t),L=l(t,"IMG",{src:!0,alt:!0}),V=p(t),c=l(t,"P",{});var it=lt(c);rt=C(it,"Therefore, the state space is gigantic; due to this, creating and updating a Q-table for that environment would not be efficient. In this case, the best idea is to approximate the Q-values using a parametrized Q-function "),X=ct(it,!1),Y=C(it,"  ."),it.forEach(s),Z=p(t),M=l(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1dwltuz"&&(M.textContent=Lt),tt=p(t),Q=l(t,"IMG",{src:!0,alt:!0}),st=p(t),T=l(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-9k1cpu"&&(T.textContent=Qt),at=p(t),zt(k.$$.fragment,t),et=p(t),q=l(t,"P",{}),lt(q).forEach(s),this.h()},h(){$(o,"name","hf:doc:metadata"),$(o,"content",Bt),U.a=B,O.a=W,Tt(L.src,yt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/atari.jpg")||$(L,"src",yt),$(L,"alt","Atari State Space"),X.a=Y,Tt(Q.src,Mt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/deep.jpg")||$(Q,"src",Mt),$(Q,"alt","Deep Q Learning")},m(t,a){u(document.head,o),e(t,A,a),e(t,P,a),e(t,E,a),Ht(g,t,a),e(t,I,a),e(t,f,a),e(t,G,a),e(t,d,a),e(t,S,a),e(t,v,a),e(t,D,a),e(t,w,a),e(t,F,a),e(t,x,a),e(t,j,a),e(t,b,a),e(t,N,a),e(t,_,a),e(t,R,a),e(t,m,a),u(m,pt),u(m,z),u(m,mt),U.m(qt,m),u(m,B),O.m(At,m),u(m,W),e(t,J,a),e(t,y,a),e(t,K,a),e(t,L,a),e(t,V,a),e(t,c,a),u(c,rt),X.m(Et,c),u(c,Y),e(t,Z,a),e(t,M,a),e(t,tt,a),e(t,Q,a),e(t,st,a),e(t,T,a),e(t,at,a),Ht(k,t,a),e(t,et,a),e(t,q,a),nt=!0},p:Gt,i(t){nt||(Ct(g.$$.fragment,t),Ct(k.$$.fragment,t),nt=!0)},o(t){$t(g.$$.fragment,t),$t(k.$$.fragment,t),nt=!1},d(t){t&&(s(A),s(P),s(E),s(I),s(f),s(G),s(d),s(S),s(v),s(D),s(w),s(F),s(x),s(j),s(b),s(N),s(_),s(R),s(m),s(J),s(y),s(K),s(L),s(V),s(c),s(Z),s(M),s(tt),s(Q),s(st),s(T),s(at),s(et),s(q)),s(o),Pt(g,t),Pt(k,t)}}}const Bt='{"title":"From Q-Learning to Deep Q-Learning","local":"from-q-to-dqn","sections":[],"depth":1}';function Ot(ht){return St(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Vt extends Dt{constructor(o){super(),Ft(this,o,Ot,Ut,It,{})}}export{Vt as component};
